# BlockBattle
A falling-blocks game where the pieces happen to have four blocks apiece. Originally intended for the [Pokitto](https://www.pokitto.com/) DIY handheld gaming system.

The goal of this is to make a fun falling blocks game that plays like another game, but with my own characters/abilities.

## Special Abilities
One special feature of this dueling-puzzle game is the ability to choose a character with different special abilities. Each character has for special abilities to choose from: Level 1, Level 2, Level 3, and Ultimate.

Abilities are used by collecting Power Spheres scattered through the playfield. If a player has more Power Spheres than are needed for a givel level, the highest **full** level is used. All Power Spheres are consumed when using any Special Ability.

While their powers are different, all characters share the same Ultimate ability: a total board wipe of all blocks and hard blocks.

## Story
A dimensional portal has opened, and out of it come several unnatural beings: the spider queen Arachna, the fire demon Ifthon, and the psychically-powered organ powered by pure hate: Brain...Guy.

The perverse nature of these evil creatures brings a reaction from the planet itself. Bending rock to its new will, Earth God is born as the protector of the natural order.

### Earth God
Made of living stone, this powerful behemoth is the living embodiment of the planet's hatred toward these abominations. Earth God relies on brute strength to pulverize his opponents.

* Level 1: Righteous Smash - Smash bottom four rows
* Level 2: Raise Earth - Add four rows to bottom of opponent's stack
* Level 3: Gaia's Vengeance - Blow up random portions of opponent stack including crystals

### Ifthon
What could be called an imp in classic literature, Ifthon is a being made purely of dark energy. While it's sneaky and mischevious, Ifthon tends to use its power more defensively.

* Level 1: Dark Wind - Push all blocks to one side
* Level 2: Sneaky Mirror - Switch empty spaces and blocks
* Level 3: Power Drain - Steal a random number of Power Spheres

### Arachna
Part spider, part human, all evil. Arachna is the queen of all spiders in her realm. She uses her arachnid abilities to paralyze opponents before summoning her spider swarm to bleed them dry.

* Level 1: Paralyze - Opponent cannot rotate next three pieces
* Level 2: Spider Swap - Switch playfields with opponent
* Level 3: Swarm - Shuffle opponent's stack

### Brain...Guy
It doesn't speak, so nobody knows what to call it before being crushed by its telekinetic abilities. Brain...Guy uses its pychic power to toy with opponents before happily obliterating them.

* Level 1: Head Clear - Push blocks to either side from the middle
* Level 2: Suspension - Lines do not drop on clear for opponent's next six pieces
* Level 3: Psychic Tap - Hard drop disabled for opponent's next four pieces

## Implementation
I started remaking this for TIC-80, but have not yet converted the higher-color mockups to Sweetie16.

### Media
Some TIC-80 sprites for testing pieces. Using 5x5 so I can fit a full-height well on screen:

![wip-01](wip-01.png)

Original mockup for Pokitto, which will need extensive rework. I'll have much more screen width to work with, and there's the double-well scenario to think about:

![pokitto-mockup](pokitto-mockup.png)